<%@ WebHandler Language="C#" Class="proxy" %>

using System;
using System.IO;
using System.Net;
using System.Web;


public class proxy : IHttpHandler
{
    public void ProcessRequest(HttpContext context)
    {

        HttpResponse response = context.Response;

        if (context.Request.UrlReferrer == null ||
          context.Request.UrlReferrer.Host.Length == 0 ||
          context.Request.UrlReferrer.Host.CompareTo(
          context.Request.Url.Host.ToString()) != 0)
        {
            response.StatusCode = 403;
            response.End();
            return;
        }

        // Check for query string
        string uri = Uri.UnescapeDataString(context.Request.QueryString.ToString());

        // Filter requests
        if (!uri.ToLowerInvariant().Contains("www.waze.com"))
        {
            response.StatusCode = 403;
            response.End();
            return;
        }

        string location = context.Request.Headers["Location"];
        if (location != null)
        {
            HttpContext.Current.Trace.Write("#GPS:" + location);
        }

        // Create web request
        WebRequest webRequest = WebRequest.Create(new Uri(uri));
        webRequest.Method = context.Request.HttpMethod;

        // Send the request to the server
        WebResponse serverResponse = null;
        try
        {
            serverResponse = webRequest.GetResponse();
        }
        catch (WebException webExc)
        {
            response.StatusCode = 500;
            response.StatusDescription = webExc.Status.ToString();
            response.Write(webExc.Response);
            response.End();
            return;
        }

        // Exit if invalid response
        if (serverResponse == null)
        {
            response.End();
            return;
        }

        // Configure reponse
        //response.ContentType = serverResponse.ContentType;
        Stream stream = serverResponse.GetResponseStream();
        response.ContentType = "text/plain";

        byte[] buffer = new byte[32768 * 4];
        int read;
        while ((read = stream.Read(buffer, 0, buffer.Length)) > 0)
        {
            response.OutputStream.Write(buffer, 0, read);
        }

        serverResponse.Close();
        stream.Close();
        response.End();
    }
    public bool IsReusable
    {
        get { return true; }
    }
}

